Global("MButton", nil)
Global( "wtSpellInfoTextView", nil )
Global( "wtMPanel", nil )
Global( "wtInfoPanel", nil )
Global( "wtInfoTextView", nil )
Global( "ITextView", {} )
Global( "ISpellView", {} )
Global( "ISpellPanel", {} )
Global( "widgetTextDesc", nil )
Global( "widgetSpellDesc", nil )
Global( "widgetPanelDesc", nil )

Global("AddCand", false)
Global("Cand", nil)
Global("MaxContrHeals", 10)
Global("MaxContrUnits", 10)


function HealLog(CurHeal)
local ava = CheckHealer(CurHeal.healerId)
--common.LogInfo(common.GetAddonName(),"ava=",common.FormatInt(ava, "%i"))
	if ava > 0 then
		AddSpellData(CurHeal, ava)
		if not mainForm:IsVisible() then
			mainForm:Show(true)
		end
		local AH = MData[ava].AllHeal + MData[ava].AllCutHeal
		local PerRes = MData[ava].AllResHeal + MData[ava].AllHeal
		if PerRes > 0 then
			PerRes = 100 * MData[ava].AllResHeal / PerRes
		else
			PerRes = 0
		end
			wtSpellInfoTextView:SetVal("Name", common.FormatFloat( AH, "%f3K5" ) )
			wtSpellInfoTextView:SetVal("Resist",common.FormatFloat( PerRes, "%.1f" ) )
			--wtSpellInfoTextView:SetVal("Crit", common.FormatFloat( MData.CritCount, "%.1f" ) )
			--wtSpellInfoTextView:SetVal("UnHit", common.FormatFloat( MData.UHitCount, "%.1f" ) )
	--[[else
		if CurHeal.healerId then
			common.LogInfo(common.GetAddonName(),"Healer=",object.GetName(CurHeal.healerId),", Heal=",common.FormatInt(CurHeal.heal,"%n"))
		end]]
	end
end

function AllDataReset ()
if avatar.IsExist() then
	MData = {}
	DataReset (avatar.GetId())
	local nl = 0
	wtSpellInfoTextView:SetVal("Name", common.FormatFloat(nl,"%f3K5"))
	wtSpellInfoTextView:SetVal("Resist",common.FormatFloat(nl,"%.1f"))
	ISpellPanel[1]:SetBackgroundColor( { r = 0.8; g = 0.8; b = 0.3; a = 0.6 } )
	end
end

function DataReset(AvaId)
MData = {}
AddNewMajorData (AvaId)
local hY = wtInfoPanel:GetPlacementPlain()
hY.sizeY = 0
wtInfoPanel:SetPlacementPlain(hY)
end

function OnMButtonReaction(params)
	--if AddCand then
		--AddNewMajorData (Cand)
		--AddCand = false
	--else
		AllDataReset ()
	--end
end

function HealPanel ()
	if wtInfoPanel:IsVisible() then
		wtInfoPanel:Show(false)
	else
		wtInfoPanel:Show(true)
		--if GetTableSize(MData) > 1 then
			ShowData (1)	--  1
		--end
	end
end

function SaveData ()
--reserved
end

function AvLogOut (sec)
if sec.delay < 1 then
	if SpCnt >0 then
		SaveData ()
		--common.LogInfo(common.GetAddonName(),"^--^--^-----. .----^--^--^")
	end
end
end

function CreateITW (num)
ITextView[num] = mainForm:CreateWidgetByDesc(widgetTextDesc)
ISpellView[num] = mainForm:CreateWidgetByDesc(widgetSpellDesc)
ISpellPanel[num] = mainForm:CreateWidgetByDesc(widgetPanelDesc)
wtInfoPanel:AddChild(ITextView[num])
wtInfoPanel:AddChild(ISpellView[num])
wtInfoPanel:AddChild(ISpellPanel[num])

local p = ITextView[num]:GetPlacementPlain()
p.posY = p.posY + 42*(num-1)
ITextView[num]:SetPlacementPlain(p)

p = ISpellView[num]:GetPlacementPlain()
p.posY = p.posY + 42*(num-1)
ISpellView[num]:SetPlacementPlain(p)
ISpellPanel[num]:SetPlacementPlain(p)
ISpellPanel[num]:SetBackgroundColor( { r = 0.8; g = 0.8; b = 0.3; a = 0.6 } )

end

function ShowData (MajorNum)
if not MData[MajorNum] then return
end
if not MData[MajorNum].OneHealData then return
end
local SpCnt = GetTableSize(MData[MajorNum].OneHealData)
if SpCnt > 0 then
	local CRT
	local UNH
	local AllHeal
	local MidHeal
	local RHP
	--common.LogInfo(common.GetAddonName(),"-------------")
	for i=1, SpCnt do
		CRT = 100 * MData[MajorNum].OneHealData[i].CritCount / MData[MajorNum].OneHealData[i].SpellCount
		UNH = 100 * MData[MajorNum].OneHealData[i].UHitCount / MData[MajorNum].OneHealData[i].SpellCount
		AllHeal = MData[MajorNum].OneHealData[i].Heal + MData[MajorNum].OneHealData[i].CutHeal
		MidHeal = 0
		RHP = 0
		if MData[MajorNum].OneHealData[i].HealCount > 0 then
			MidHeal = MData[MajorNum].OneHealData[i].Heal / MData[MajorNum].OneHealData[i].HealCount
			if MData[MajorNum].OneHealData[i].Heal then
				RHP = 100 * MData[MajorNum].OneHealData[i].ResHeal / (MData[MajorNum].OneHealData[i].ResHeal + MData[MajorNum].OneHealData[i].Heal)
			end
		end
		MData[MajorNum].NewData = false
		if not ITextView[i] then CreateITW(i)
		end
		ISpellView[i]:SetVal("Name", MData[MajorNum].OneHealData[i].spebuab)
		ISpellView[i]:SetVal("FHeal", common.FormatFloat(AllHeal,"%f3K5"))
		ISpellView[i]:SetVal("Cnt", common.FormatInt(MData[MajorNum].OneHealData[i].SpellCount,"%i"))
		ITextView[i]:SetVal("MHeal", common.FormatFloat(MidHeal,"%.1f"))
		ITextView[i]:SetVal("PerUH", common.FormatFloat(RHP,"%.1f"))
		ITextView[i]:SetVal("Crit", common.FormatFloat(CRT,"%.1f"))
		ITextView[i]:SetVal("UnHit", common.FormatFloat(UNH,"%.1f"))
		
		CRT = ISpellView[i]:GetPlacementPlain()
		CRT.sizeX = CRT.sizeX * AllHeal / (MData[MajorNum].AllHeal + MData[MajorNum].AllCutHeal)
		ISpellPanel[i]:SetPlacementPlain(CRT)
		--common.LogInfo(common.GetAddonName(),common.FormatFloat(MidHeal,"%.2f"))
		--common.LogInfo(common.GetAddonName(),common.FormatFloat(AllHeal,"%.2f"), " - ",common.FormatFloat(MData[MajorNum].AllHeal,"%.2f"))
		
	end
	--common.LogInfo(common.GetAddonName(),MData[MajorNum].OneHealData[1].spebuab)
	CRT = wtInfoPanel:GetPlacementPlain()
	CRT.sizeY = SpCnt*42 + 10
	wtInfoPanel:SetPlacementPlain(CRT)
end
end

function SelectCand ()
AddCand = false
Cand = avatar.GetTarget()
if Cand then
--if unit.GetClass(Cand)
AddCand = true
--AddNewMajorData (Cand)
end
end

function HideForm ()
if GetTableSize(MData[1].OneHealData) < 1 then
	mainForm:Show(false)
end
--common.LogInfo(common.GetAddonName(),"EVENT_AVATAR_CLIENT_ZONE_CHANGED")
end



function Init()
	MButton = mainForm:GetChildChecked("MButton", false)
	wtMPanel = mainForm:GetChildChecked("MainPanel", false)
	wtSpellInfoTextView = wtMPanel:GetChildChecked("MSText", false)
	
	wtInfoPanel = mainForm:GetChildChecked("InfoPanel", false)
	wtInfoPanel:Show(false)
	
	ITextView[1] = wtInfoPanel:GetChildChecked("InfoText", false)
	ISpellView[1] = wtInfoPanel:GetChildChecked("InfoSpell", false)
	ISpellPanel[1] = wtInfoPanel:GetChildChecked("PerPanel", false)
	ISpellPanel[1]:SetBackgroundColor( { r = 0.8; g = 0.8; b = 0.8; a = 0.6 } )
	
	widgetTextDesc = ITextView[1]:GetWidgetDesc()
	widgetSpellDesc = ISpellView[1]:GetWidgetDesc()
	widgetPanelDesc = ISpellPanel[1]:GetWidgetDesc()


	common.RegisterEventHandler(HealLog, "EVENT_HEALING_RECEIVED" )
	common.RegisterEventHandler(AvLogOut, "EVENT_AVATAR_WILL_BE_REMOVED" )
	common.RegisterEventHandler(HideForm, "EVENT_AVATAR_CLIENT_ZONE_CHANGED" )
	common.RegisterEventHandler(AllDataReset, "EVENT_AVATAR_CREATED" )
	common.RegisterEventHandler(SelectCand, "EVENT_AVATAR_PRIMARY_TARGET_CHANGED" )
	
	common.RegisterReactionHandler(OnMButtonReaction, "MButtonReaction")
	common.RegisterReactionHandler(HealPanel, "MainPanelOnMouseMove1" )
	AllDataReset()
	--if avatar.IsExist() then
		--DataReset (avatar.GetId())
	--end
end

Init()
