--Global("SpCnt", 0)
Global("FullData", {})
Global ("MData",{})
--------

function GetTableSize(t)
if not t then
	return 0
end
local count = 0
for k, v in t do
	count = count + 1
end
return count
end

function AddNewMajorData (PlrId)
local TmpData = {
	["NewData"] = false,	-- 
	["PlayerId"] = PlrId,	-- 
	["AllHeal"] = 0,		-- 
	["AllCutHeal"] = 0,		--  
	["AllResHeal"] = 0,		--  
	["AllHealCount"] = 0,	-- 
	["OneHealData"] = {}
}
--common.LogInfo(common.GetAddonName(),common.FormatInt( PlrId, "%i" ))
local s = GetTableSize(MData)+1
MData[s] = TmpData
end

function CheckHealer (hId)
if MData then
	for i=1, GetTableSize(MData) do
		if MData[i].PlayerId == hId then
			return i
		end
	end
end
return 0
end

function HealName (OneHeal)
local nme = userMods.ToWString("")
local spl = nil
if OneHeal.abilityId then
	spl = avatar.GetabilityInfo(OneHeal.abilityId)
elseif OneHeal.buffId then
	spl = avatar.GetBuffInfoById(OneHeal.buffId)
else
	spl = avatar.GetSpellInfo(OneHeal.spellId)
end
if spl then
	if not common.IsEmptyWString (spl.name) then
		nme = spl.name
	end
end
return nme
end

function CheckHeal (OneHeal,MajorNum)
local SpCnt = GetTableSize(MData[MajorNum].OneHealData)
if SpCnt > 0 then
	for i=1, SpCnt do
		if common.CompareWString(MData[MajorNum].OneHealData[i].spebuab, HealName(OneHeal)) == 0 then
			return i
		end
	end
end
--common.LogInfo( common.GetAddonName(),"CheckHeal: -1 - ", common.FormatInt( SpCnt, "%i" ))
return 0
end


function AddSpellData (OneHeal, MajorNum)
	local NilData = {
	["spebuab"] = common.GetEmptyWString(),
	["Heal"] = 0,			--  
	["CutHeal"] =0,			--  (  100% )
	["ResHeal"] =0,			--  
	["AbsHeal"] =0,			--  
	["SpellCount"] = 0,		--  
	["HealCount"] = 0,		--  
	["CritCount"] = 0,		--  
	["UHitCount"] =0		--  
	}
	local Check = CheckHeal(OneHeal,MajorNum)
	if Check < 1 then
		Check = GetTableSize(MData[MajorNum].OneHealData) + 1
		if Check > MaxContrHeals then return
		end
		MData[MajorNum].OneHealData[Check] = NilData
		MData[MajorNum].OneHealData[Check].spebuab = HealName(OneHeal)
	end
	MData[MajorNum].NewData = true
	MData[MajorNum].OneHealData[Check].SpellCount = MData[MajorNum].OneHealData[Check].SpellCount + 1
	if OneHeal.isCritical then
		MData[MajorNum].OneHealData[Check].CritCount = MData[MajorNum].OneHealData[Check].CritCount + 1
	elseif OneHeal.isGlancing then
		MData[MajorNum].OneHealData[Check].UHitCount = MData[MajorNum].OneHealData[Check].UHitCount + 1
	end
	if OneHeal.healthLevel < 100 then
		MData[MajorNum].OneHealData[Check].Heal = MData[MajorNum].OneHealData[Check].Heal + OneHeal.heal
		MData[MajorNum].OneHealData[Check].ResHeal = MData[MajorNum].OneHealData[Check].ResHeal + OneHeal.resisted
		MData[MajorNum].OneHealData[Check].AbsHeal = MData[MajorNum].OneHealData[Check].AbsHeal + OneHeal.absorbed
		MData[MajorNum].AllHeal = MData[MajorNum].AllHeal + OneHeal.heal
		MData[MajorNum].AllResHeal = MData[MajorNum].AllResHeal + OneHeal.resisted
		MData[MajorNum].AllHealCount = MData[MajorNum].AllHealCount + 1
		MData[MajorNum].OneHealData[Check].HealCount = MData[MajorNum].OneHealData[Check].HealCount + 1
	else
		MData[MajorNum].AllCutHeal = MData[MajorNum].AllCutHeal + OneHeal.heal
		MData[MajorNum].OneHealData[Check].CutHeal = MData[MajorNum].OneHealData[Check].CutHeal + OneHeal.heal
	end
	
	-------
	--[[if MData[MajorNum].OneHealData[Check].AbsHeal > 0 then
		common.LogInfo( common.GetAddonName(),"AbsHeal:= ",common.FormatInt(MData[MajorNum].OneHealData[Check].AbsHeal, "%i" ))
	end]]
end